#include <stdio.h>

#include "global.h"

#define MAXVAL	100		/* maximum depth of val stack */

int sp = 0;				/* next free stack position */
double val[MAXVAL];		/* value stack */

/* push: push f onto value stack */
void push(double f)
{
	if (sp < MAXVAL)
		val[sp++] = f;
	else
		printf("error: stack full, can't push %g\n", f);
}

/* pop: pop and return top value from stack */
double pop(void)
{
	if (sp > 0)
		return val[--sp];
	else
	{
		printf("error: stack empty\n");
		return 0.0;
	}
}

/* get top value of the stack, same as pop but does not delete it */
double getvalue(void)
{
	if (sp > 0)
		return val[sp - 1];
	else
	{
		printf("error: stack empty\n");
		return 0.0;
	}
}

/* get second value of stack */
double getvalue2(void)
{
	if (sp > 1)
		return val[sp - 2];
	else
	{
		printf("error: less than 2 elements in stack\n");
		return 0.0;
	}
}

/* duplicate last given value to next value */
void duplicate(void)
{
	if (sp > 0)
	{
		val[sp] = val[sp - 1];
		sp++;
	}
	else
		printf("error: stack empty\n");
}

/* swaps the top elements of the stack */
void swap(void)
{
	if (sp > 1)
	{
		double temp = val[sp - 1];
		val[sp - 1] = val[sp - 2];
		val[sp - 2] = temp;
	}
	else
		printf("error: less than two elements in stack\n");
}

/* clears the stack */
void clear(void)
{
	sp = 0;
}

int getStackSize(void)
{
	return sp;
}
